#!/usr/bin/python


# This program is free software.
# This code is a part of Octave-GTK
# Code may be used or distributed under GPL.
# (C) July 2005 Muthiah Annamalai, Octave-GTK


#
# Code modified for generating specifics to G2 library.
#
#

#rest of the types are scalar, and passed as such.

import AutoGenDefs
import time

typemap = {"gchar*":"string",
           "char *":"string",
           "void*":"long int",
           "GType":"long int",
           "GtkSignalFunc":"string",
           "gpointer":"long int",
           "gboolen":"long int",
           "double *":"points"
           }
#what doesnt figure in the typemap list ought to be an integer.
#if its a pointer, the use a `long int'

def is_pointer_type(ret_type):
    if ret_type.find("*")>=0:
        return True
    elif ret_type.find("pointer")>=0:
        return True
    else:
        return False
    return False
    
def gen_code(ret_type,fun_name,arg_list,cname):

    """
    The great Code Generator!
    ret_type: return type of the C function call
    fun_name: name of the C function to be called
    arg_list: a list of argument dictionaries [key, value] pairs.
    cname: the  'C' function declaration.
    """
    empty_arg_list=False;
    var_args=False
    arg_list = arg_list ;

    #print "rt=",ret_type
    #print "fn=",fun_name
    #print "al=",arg_list
    #print "cn=",cname

    if(len(arg_list)==0 or arg_list[0].keys()[0]=="void"):
        print "/* void: zero arguments taken */"
        empty_arg_list=True

    fun_name=fun_name.split("(")[0]
    print "DEFUN_DLD(",fun_name,",","args",",",",","\"",cname,"\"",")"
    print "{"
    if arg_list=={'':''}:
        #print "Empty Argument List" #error reporting
        empty_arg_list=True;

    #prints the argument 'C' container declarations
    for i in arg_list:
        key=i.keys()[0]
        if(key==""):
            continue
        else:
            if not empty_arg_list:
                if(key=="GtkSignalFunc" or
                   key=="GtkFunction"):
                    print "string"," ",i[key],"; "
                elif key=="...":
                    print "/* varargs must come here for [...]",i[key] ,"*/"
                    var_args=True
                else:
                    print key," ",i[key],";"
                pass
            pass
        pass
    
    #prints the argument checking stuff.
    if empty_arg_list:
        pass
    else:
        if not var_args:
            print " if(args.length()!=",len(arg_list),")"
        else:
            print " if(args.length()!=",len(arg_list)-1,")"
        print "  {"
        print "   std::cout<<","\"eg: ",cname,"\"","<<std::endl;"
        print "   return octave_value(-1);"
        print "  }"
    
    #announce DEBUGGING purposes only.
    print "#ifdef DEBUG"
    print "std::cout<<\"",fun_name,"\"<<std::endl;"
    print "#endif /* DEBUG */"

    #deferred code. [used for cleanup effects, after calling function] eg: delete,fflush,allocation.
    deferred_code=False
    deferred_statement=[]    
    
    #convert the types
    for i in range(0,len(arg_list)):
        x=[arg_list[i].keys()[0],arg_list[i].values()[0]]

        #At this point, 'x' is split into [type,varname].
        if(x[0].find("char *")>=0):
            print x[1],"=","new ",x[0].split("*")[0]," [args(",i,").string_value ().length()];"
            print "strcpy( (char *)",x[1],",args(",i,").string_value().c_str());"
            #print x[1],"=","(",x[0].split("*")[0],"*)g_malloc( sizeof(char)*args(",i,").string_value().length());"
            #print "strcpy( (char *)",x[1],",args(",i,").string_value().c_str());"
            #deferred_statement+=["g_free ("+x[1]+");"]
            #causing segfaults!! where is the reference stored?
            #deferred_code=True;
            #deferred_statement+=["delete "+x[1]+";"]
        elif(x[0].find("GtkSignalFunc")>=0):
            print "string callback_fcn","=args(",i,").string_value();"
            print "g_object_set_data(G_OBJECT(",arg_list[0].values()[0],"),",arg_list[1].values()[0]+",(void *)callback_fcn.c_str());"
            print ""
        elif (x[0].find("GtkFunction")>=0):
            print "string callback_fcn","=args(",i,").string_value();"
            print ""
        elif(x[0].find("FILE")>=0):
            tmp_var_name="_"+x[1].strip()
            tmp_id_name="octave_stream_list::get_file_number(args(%d))"%i
            print "{"
            print "string mode_str;"
            print tmp_var_name,"= octave_stream_list::lookup(\\"
            print tmp_id_name,");"
            print "mode_str=",tmp_var_name,".mode_as_string(",tmp_var_name,".mode());"
            print tmp_var_name[1:],"= fdopen( (",tmp_id_name,"+1)",",","mode_str.c_str());"
            print "}"
            deferred_code=True
            deferred_statement+=["fflush("+tmp_var_name[1:]+");"]
            del tmp_var_name
            del tmp_id_name
        elif(x[0].find("double *")>=0  and x[1].find("points")>=0):
             tmp_var_name = "_"+x[1];
             print "Matrix ",tmp_var_name,"= args(",i,").matrix_value();"
             print x[1],"  = new double[",tmp_var_name,".cols()];"
             print "for(int i=0;i<",tmp_var_name,".cols();i++){"
             print x[1],"[i]  = ",tmp_var_name,"(i);";
             print "}"

             deferred_code = True;
             deferred_statement += ["delete "+x[1]+";"];

             del tmp_var_name
        elif(x[0].find("*")>=0): #
            tmp_var_name= x[1]
            tmp_type_name=x[0][:-1]
            print tmp_var_name,"=(",x[0],")args(",i,").long_value();" 
            del tmp_var_name
            del tmp_type_name
        elif(x[0].find("pointer")>=0): #
            tmp_var_name= x[1]
            tmp_type_name=x[0][:-1]
            print tmp_var_name,"=(",x[0],")args(",i,").long_value();"
            del tmp_var_name
            del tmp_type_name
        elif(x[0]=="void"):
            continue;
        elif x[0].find("float") >=0:
            print x[1],"=","( ",x[0]," )","args(",i,").double_value();"        
        elif x[0].find("double") >=0:
            print x[1],"=","( ",x[0]," )","args(",i,").double_value();"
        elif x[0].find("long int")>=0:
            print x[1],"=","( ",x[0]," )","args(",i,").ulong_value();"
        elif x[0].find("int")>=0:
            print x[1],"=","( ",x[0]," )","args(",i,").int_value();"
        elif x[0].strip()=="":
            print "/* Nothing! */"
        elif x[0].find("...") >=0:
            print "/* Variable Arguments ?? */"
        else:
            print x[1],"=","( ",x[0]," )","args(",i,").long_value();"


    #call the function.
    op_str=""
    for i in range(0,len(arg_list)):
        x=[arg_list[i].keys()[0],arg_list[i].values()[0]]
        if(len(x)!=2):
            continue;
        
        if( x[0].find("GtkFunction")>=0):
            op_str+="octave_gtk_function"
            pass
        elif (x[0].find("GtkSignalFunc")>=0):
            op_str+="octave_gtk_signal_function"
            pass
        elif (x[0].find("...")>=0):
            print "/* ignoring varargs [...]*/"
            op_str+="NULL";
            continue
        else:
            op_str+=x[1]
            
        if i != (len(arg_list)-1):
            op_str+=","
    
    if  is_pointer_type(ret_type):
        if ret_type.find("char")>=0:
            print "string  ret_type(  (const char *)",fun_name,"(",op_str+"));"
            sys.stderr.write("string ret_type=new string( (const char *)"+fun_name+"("+op_str+"));")
        else:
            print "long int ret_type= (long int)",fun_name,"(",op_str+");"
        #print "GdBoxed *obj;" #replaces the older gd_octave_ptr(check/save)
        #print "obj=GdBoxed::save_ptr(ret_type,\""+ret_type.strip()+"\");" #save pointer for later use
    elif ret_type!="void":
        print "long int ret_type=(long int)",fun_name,"(",op_str+");"
    else:
        print  fun_name,"(",op_str+");"

    #generate deferred_code
    #deferred_statement's must have a ';' at their end
    if deferred_code:
        for i in deferred_statement:
            print i
    deferred_code=False
    deferred_statement=[]

    if is_pointer_type(ret_type):
        #ret_type[-1]=="*" or ret_type!="void":        
        #print "return octave_value(ret_type);"
        print "return octave_value(ret_type);"
    elif ret_type!="void":
        print "return octave_value(ret_type);"
    else:
        print "return octave_value();"
    print "}"

#
#Code generator 
#
def codegen_start(module_name,override_defs,header_defs):   
    #module_name, gives if we are doing GTK/GDK.

    print "/* Standard headers std.header */"    
    fp=open(header_defs)
    l=fp.readlines()
    for i in l:    
        if i[-1]=='\n':
            print i[:-1]
        else:
            print i
    fp.close()
    del l

    fp=open(override_defs)
    override_fcns=fp.readlines()
    for i in range(0,len(override_fcns)):
        override_fcns[i]=override_fcns[i].strip()
    fp.close()

    function_list=AutoGenDefs.function_list; #present in gtkdefs.py
    
    fcnlist=[]
    for func_record in function_list:                
        fname=func_record[1];
        sys.stderr.write("-+-"+str(fname)+"-+-\n");
        if(fname[0]=="_" or (not fname[0].isalpha())):
            sys.stderr.write("Dropping private function: "+fname+"\n")
            continue
        
        ret_type=func_record[0];
        alist=func_record[2]

        
        #print "Debug String",ret_type,":",fname,":",alist #debug string.        
        try:
            if override_fcns.index(fname.strip()) >= 0:
                print "/* overriden:",fname," */"
                fcnlist.append(fname.strip());
                del override_fcns[override_fcns.index(fname.strip())]
                continue
        except ValueError, e:
            pass #keep silent        
        if alist[0].keys()[0]=="void":
            cname="void"
        else:
            cname=""
            for i in alist:
                cname=cname + i.keys()[0] +" "+i.values()[0]+","
            cname=cname[:-1]
        
        gen_code(ret_type,fname,alist,"".join(ret_type)\
                 +" "+"".join(fname)+" ("+cname+");")
        fcnlist.append(fname.strip());

######################
#                    #
#       break        #
#                    #
######################        
        pass

    fcnlist+=override_fcns
    print "/* Overridden functions */"
    print "/* Linked Separately */"

    
    #overrides are compiled separately.
    #ovp=open("./overrides.cpp")
    #l=ovp.readlines()
    #for i in l:
    #    print i.strip()

    print "DEFUN_DLD(",module_name,",","args",",",",","\"","void "+module_name +"(void);","\"",")"
    print "{"
    #load ENUM def...
    try:
        for i in open("./enumdef.cpp").readlines():
            if len(i.strip())>=0:
                print i.strip()
    except:
        sys.stderr.write("Cannot Find 'enumdef.cpp: exception handled.")
        pass

    try:
        for i in open("stockdef.cpp").readlines(): print i
    except:
        sys.stderr.write("Cannot Find 'stockdef.cpp: exception handled.")
        pass
            
    for i in fcnlist:
        if len(i.strip()) > 0:
            print "octave_dynamic_loader::load(\""+i+"\"",",\"\");"
        else:
            print "/* Empty function [%s] */"%i
    infostr="Code generated on"+time.asctime()+ "\\n Compiled on \" __DATE__  __TIME__ "+"\"\\n loaded"+ module_name+"Library!"
    print "return octave_value(\""+infostr+"\");"        
    print "}"
    fp.close()
    return None

#
#
# BEGINNING of the CODE GENERATOR
#
if __name__=="__main__":
    #print "Starting Code Generator"
    import sys
    if(len(sys.argv)!=3):
        print "usage: ./codegen.py [override] [header]"
        print "eg:./codegen.py ./overrides ./std.header "
        sys.exit(1)

    module=sys.argv[1].replace("/","")
    module=module[module.find(".")+1:module.rfind(".")]
    
    codegen_start(module,sys.argv[1],sys.argv[2])
    print ""
#./codegen.py ./overrides ./std.header  > gtk.cpp
