#! /usr/bin/python

# This program is free software.
# This code is a part of Octave-GTK
# Code may be used or distributed under GPL.
# (C) Feb 2005 Muthiah Annamalai, Octave-GTK


import sys
import re
import glob
import os
import time
import structer


class FunMatch:
    def __init__(self):
        self.ObjList=[]
        pass

    def totalDump(self):
        structer.writeFormat(self.ObjList)
        return
    
    def funmatch(self,filename):
	"""This function does the job of reading the header file @filename
	and extracting the function definitions from it, and saves the
	function definition into a ObjList[] list.
	"""
        filp=open(filename)
        data=filp.readlines()
        
        fcnlist=[]
        funcdef=[]
        infunc=False
        incomment=False
        instruct=False
    

        #sys.stderr.write("In FunMatch\n");
        
        for i in data:
            if (incomment):
                #sys.stderr.write("incomment ")
                pass
            if (instruct):
                #sys.stderr.write("instruct ")
                pass
            if (infunc):
                #sys.stderr.write("infunc ")
                pass
            #sys.stderr.write("[%s]\n"%i.strip())
            if infunc:
                if(i.find(")")>=0):
                    #sys.stderr.write("Function: [ %s]\n"%i.strip())
                    i=i.split(")")[0]+')'
                funcdef.append(i)
                if(i.find(";")>=0 or i.find(")")>=0):
                    fcnlist.append("".join(funcdef))
                    #fcnlist[-1]=fcnlist[-1].replace("\n","");                
                    #add some checks for functions.
                    if(fcnlist[-1].find("(")>=0 and fcnlist[-1].find(")")>=0):
                        pass
                    else:
                        sys.stderr.write("deleting : "+fcnlist[-1]+"\n")
                        del fcnlist[-1]
                    funcdef=[]
                    infunc=False                    
            elif incomment:
                if(i.find("*/")>=0):
                    incomment=False
            elif instruct:
                if(i.find("};")>=0 or i.find("}")>=0):
                    instruct=False;
            elif i.find("/*")==0:
                incomment=True;                
            elif i.find("{") >=0:
                instruct=True;
            elif i.find("(")>=0:
                infunc=True
                funcdef.append(i)
                #sys.stderr.write("Found Func\n");
                if(i.find(";")>=0):
                    fcnlist.append("".join(funcdef))                
                    #add some checks for functions.
                    if(fcnlist[-1].find("(")>=0 and fcnlist[-1].find(")")>=0):
                        pass
                    else:
                        sys.stderr.write("deleting : "+fcnlist[-1]+" \n");
                        del fcnlist[-1]
                    funcdef=[]
                    infunc=False
            pass

        #sys.stderr.write("Entering FcnList")
        for i in fcnlist:
            i=re.split("\s+",i);
            i=" ".join(i).strip()
            #sys.stderr.write(i+"\n");
            self.ObjList.append(structer.doTheHardWork(i));
        #sys.stderr.write("Leaving FcnList\n")

    
        

if __name__ == "__main__":
    if(len(sys.argv)>=2):
        stdout=sys.stdout
        sys.stdout=open(sys.argv[1],"w")
        tmp_file=time.asctime().replace(' ',"_");
        fobj=FunMatch()
        for files in sys.argv[1:]:
            #print "cpp ",files,"-o",tmp_file
            os.system("cpp "+ "-o"+tmp_file+"< "+ files)
            #os.system("cat "+tmp_file)
            sys.stderr.write("#listing functions in "+files+"\n")
            fobj.ObjList.append(structer.CommentStruct("# "+files+" Functions listed here"))
            fobj.funmatch("./"+tmp_file)
            fobj.ObjList.append(structer.CommentStruct("# "+"*"*10+"End of "+files+"*"*10))
        fobj.totalDump()
        sys.stdout.close()        
    else:
        sys.stderr.write("\t usage: ./funmatch.py <output header file> <file1> <file2> ...\n\n")
        sys.stderr.write("\t preferably use a [$pre-processor]$ on the <header file>\n")
        sys.stderr.write("\t before you do this funmatch magic.\n")
        sys.exit(-1)
        
    os.unlink(tmp_file)

# Logic
# Look for a line that starts with a '('. Set a flag to grab.
#   Grab till you receive ');' part.
# Now evaluate the Grab.
#   See if this grab has just one '(' & one ')'.
#   Find out if the first part of function nametoken
#   begins like '_gtk' or 'gtk'.
# Actually checking & eliminating comments,structures helps!
# Working, albeit with a preprocessor.
