#! /usr/bin/octave -q
%/*****************************************************************************
% **  Copyright (C) 1998-2001  Ljubomir Milanovic & Horst Wagner
% **  This file is part of the g2 library
% **
% **  This library is free software; you can redistribute it and/or
% **  modify it under the terms of the GNU Lesser General Public
% **  License as published by the Free Software Foundation; either
% **  version 2.1 of the License, or (at your option) any later version.
% **
% **  This library is distributed in the hope that it will be useful,
% **  but WITHOUT ANY WARRANTY; without even the implied warranty of
% **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% **  Lesser General Public License for more details.
% **
% **  You should have received a copy of the GNU Lesser General Public
% **  License along with this library; if not, write to the Free Software
% **  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
% **/
% **/*
% ** * g2_splines_demo.c
% ** * 06/16/99
% ** */
% **


disp('Splines');
g2()

function curves(id)
   dy   =   [ 10.0 , 280.0 , 140.0 , 200.0,  60.0, 120.0, 380.0,
		500.0, 480.0, 400.0, 220.0, 180.0, 260.0, 340.0 ];
    o = 60
    tn = 0.6
    n = 14

   for i=1:n;
      points(i+i)   = (i*o)+20.;       %/* from 20 to 800 (20+(13*60)) */
      points(i+i+1) = dy(i);
   end

   g2_pen(id, 1);
   g2_poly_line(id, n, points);
   g2_pen(id, 3);
   g2_spline(id, n, points, o);
   g2_pen(id, 7);
   g2_b_spline(id, n, points, o);
   g2_pen(id, 10);
   g2_raspln(id, n, points, tn);
   g2_pen(id, 19);
   g2_para_3(id, n, points);
   g2_pen(id, 22);
   g2_para_5(id, n, points);
end

function axes(id)
   g2_line(id, 5, 300, 810, 300);
   g2_line(id, 400, 5, 400, 560);
end

function draw(id)
   g2_rectangle(id, 5, 5, 810, 560);	%/* window: 815 x 565 */
   axes(id);
   curves(id);
end

function main()
    dev=[-1, -1, -1, -1, -1];

    id=g2_open_vd();				 % /* open virtual device */

    printf("\nAdding..");
    
    %printf("..PS");
    %dev[0]=g2_open_PS("g2_splines_demo.ps", g2_A4, g2_PS_land);
    %g2_attach(id, dev[0]);

    printf("..X11");
    dev(1)=g2_open_X11(850, 600);
    g2_attach(id, dev(1));

    %printf("..GD");
    %dev[2]=g2_open_gd("g2_splines_demo.png", 850, 600, g2_gd_png);
    %g2_attach(id, dev[2]);

    %printf("..WIN32");
    %dev(3)=g2_open_win32(850, 600,"g2_splines_demo",0);
    %	g2_set_auto_flush(dev(3),0);
    %g2_attach(id, dev(3));

    %printf("..WMF32");
    %dev(4)=g2_open_win32(850, 600,"g2_splines_demo.emf",1);
    %	g2_set_auto_flush(dev(3),0);
    %g2_attach(id, dev[4]);

    
    g2_set_auto_flush(id,0);   
    g2_set_coordinate_system(id, 12, 15, 1., 1.);
    
    draw(id);
    g2_flush(id);

    printf("\nDone.\n[Enter]\n");
    fgets(stdin);

    g2_close(id);
    return;
end

main()
